package com.example.springboot.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.example.springboot.entity.Auth.User;
import com.example.springboot.entity.RestBean;
import com.example.springboot.entity.User.AccountUser;
import com.example.springboot.service.UserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpSession;
import java.util.List;

@RestController
@RequestMapping("api/user")
public class UserController {


    @Autowired
    UserService userService;

    @GetMapping("/me")
//    public RestBean<AccountUser> me(@SessionAttribute("account") AccountUser user){
    public RestBean<AccountUser> me(HttpSession session, AccountUser user){
        return RestBean.success(user);
    }


    //查询所用用户
    @GetMapping("/queryList")
    public List<User> queryList() {
//        return userMapper.queryUserList();
        return userService.list();
    }

    /*//添加一个用户
    @PostMapping("/addUser")
    public int addUser(@RequestBody User user) {
        System.out.println("1111111111");
        return userMapper.insert(user);
    }*/

    //User中id为空则是创建，不为空则是修改
    @PostMapping()
    public boolean save(@RequestBody User user) {
        return userService.saveUser(user);
    }

    //根据ID删除一条数据
    @PostMapping("/{id}")
    public boolean daleteById(@PathVariable Integer id) {
        return userService.removeById(id);
    }

    //根据ID批量删除
    @PostMapping("/batch{id}")
    public boolean daleteBatch(@RequestBody List<Integer> ids) {
        return userService.removeBatchByIds(ids);
    }

    //mybatis-plus分页查询
    @GetMapping("/page")
    public IPage<User> findPage(@RequestParam Integer pageNum,
                                @RequestParam Integer pageSize,
                                @RequestParam(defaultValue = "") String name,
                                @RequestParam(defaultValue = "") String phone) {
        IPage<User> page = new Page<>(pageNum,pageSize);
        QueryWrapper<User> queryWrapper = new QueryWrapper<>();
        System.out.println("111111111111");
        if(!"".equals(name)){
            queryWrapper.like("name",name);
        }
        if (!"".equals(phone)){
            queryWrapper.like("phone",phone);
        }
        return userService.page(page,queryWrapper);
    }
    @GetMapping("/page2")
    public IPage<User> findPage(){
        int pageNum = 1;
        int pageSize = 10;
        IPage<User> page = new Page<>(pageNum,pageSize);
        QueryWrapper<User> queryWrapper = new QueryWrapper<>();
        return userService.page(page,queryWrapper);
    }
}
